/*****************************************************************************
 *
 *  Fichier: piloCntrlTaskFunc.c
 *
 *  Auteur: sf
 *  Date:   Jan 94
 *  
 *  Description: Fonctions utilisateur appelees par la tache de controle
 *               du module PILO.
 */


#include <stdio.h>
#include <portLib.h>

#include <math.h>

#include "h2mathLib.h"
#include "server/piloHeader.h"
#include "piloConst.h"
#include "piloCmdTaskCodels.h"

/*****************************************************************************
 *
 *  Fonctions de controle.
 *
 *  Retourne: OK ou ERROR
 */

STATUS controlSpeed (int *speed, int *bilan)
{
  if(*speed > 100 || *speed < 0) {
    *bilan = S_pilo_bad_parameters;
    return ERROR;
  }
  
  return OK;
}

STATUS controlDynamic (PILO_DYNAMIC_PARAMS *params, int *bilan)
{
  /* Test parameters */
  if (params->vMaxPercent < 1 || params->vMaxPercent > 100 ||
      params->wMaxPercent < 1 || params->wMaxPercent > 100 ||
      params->accelLinPercent < 1 || params->accelLinPercent > 100 ||
      params->accelAngPercent < 1 || params->accelAngPercent > 100) {
    *bilan = S_pilo_bad_parameters;
    return ERROR;
  }
  
  /* Record parameters */
  VMAX_REF = VMAX_PILO * (double) params->vMaxPercent/100.;
  WMAX_REF = WMAX_PILO * (double) params->wMaxPercent/100.;
  ALIN_REF = AMAX_LIN_PILO * (double) params->accelLinPercent/100.;
  AANG_REF = AMAX_ANG_PILO * (double) params->accelAngPercent/100.;

  return OK;
}


